local versionnumber = "0.3";

local isFrame1locked = true;
local isFrame2locked = true;
local colorcoder = "|cff00d2ff";

local zone
local TimeSinceLastUpdate = 0

local function EZThreatPrint(texttoprint)
    print("|cff66e4ffEZThreat:|r "..texttoprint);
end

-- store last known value
local lastknownthreatPct = 0;


--Slash commands
SLASH_EZTHREAT1 = "/EZThreat"
SLASH_EZTHREAT2 = "/ezt"
SlashCmdList["EZTHREAT"] = function(msg)
   --print("EZThreat - "..msg)
   local msglowercase = string.lower(msg);

    -- commands that need to pass an argument... split the string at spaces
    local rmanacmd1, rmanacmd2 = string.split(" ", msg)



   if msglowercase == "unlock" then
    --
    isFrame1locked = false;
    isFrame2locked = false;
    EZThreatPrint("Frames are now unlocked.");

   elseif msglowercase == "lock" then
    --
    isFrame1locked = true;
    isFrame2locked = true;
    EZThreatPrint("Frames are now locked.");


    --save the frame positions (anchor1, nil, anchor2, x, y)
    p1, _, p3, barx, bary = EZThreat_Frame:GetPoint();
    pp1, _, pp3, txtx, txty = EZThreat:GetPoint();

    EZThreatSettings["Frame2X"] = barx;
    EZThreatSettings["Frame2Y"] = bary;
    EZThreatSettings["Frame2Anchor1"] = p1;
    EZThreatSettings["Frame2Anchor2"] = p3;

    EZThreatSettings["Frame1X"] = txtx;
    EZThreatSettings["Frame1Y"] = txty;
    EZThreatSettings["Frame1Anchor1"] = pp1;
    EZThreatSettings["Frame1Anchor2"] = pp3;

    EZThreatPrint("Saved frame positions.");
    --print("bar = X: "..barx.."  Y: "..bary.." - "..p1.."-"..p3);
    --print("txt = X: "..txtx.."  Y: "..txty.." - "..pp1.."-"..pp3);



    elseif msglowercase == "debug" then
    --DEBUGGING
    print("txt = X: "..EZThreatSettings["Frame1X"].."  Y: "..EZThreatSettings["Frame1Y"]);
    print("bar = X: "..EZThreatSettings["Frame2X"].."  Y: "..EZThreatSettings["Frame2Y"]);
    

   elseif msglowercase == "lostframe" or msglowercase == "reset" or msglowercase == "lost" then
        EZThreatPrint("Moving EZThreat Frames to the middle of your screen...");

        local scalebar = EZThreat_Frame:GetEffectiveScale();
        local scaletxt = EZThreat:GetEffectiveScale();
        local xx, yy = GetCursorPosition();
        EZThreat_Frame:ClearAllPoints();
        EZThreat_Frame:SetPoint("CENTER","UIParent","CENTER",0,0);

        EZThreat:ClearAllPoints();
        EZThreat:SetPoint("CENTER","UIParent","CENTER",0,0);


-- /EZThreat WIDTH
    elseif rmanacmd1 == "width" then
    	-- check for a second argument
    	if not rmanacmd2 then
    		-- ERROR - SPECIFY A WIDTH - EXAMPLE USAGE
    		EZThreatPrint("ERROR: You must specify a width to set the bar width.");
    		EZThreatPrint("Example: /EZThreat width 151");
    		return
    	end

    --set the width - check that its a valid value
        local rmanavaluecheck = tonumber(rmanacmd2); -- convert string to number
        if rmanavaluecheck > 10 and rmanavaluecheck < 1000 then
        	--SET BAR WIDTH
        	EZThreat_Frame:SetWidth(rmanavaluecheck);
        	EZThreatSettings["BarWidth"] = rmanavaluecheck; -- save the setting
        else
        	--error  -  invalid value
        	EZThreatPrint("ERROR: Invalid value for bar width. Must be between 10 and 1000.");
        end

-- /EZThreat WIDTH
    elseif rmanacmd1 == "height" then
    	-- check for a second argument
    	if not rmanacmd2 then
    		-- ERROR - SPECIFY A HEIGHT - EXAMPLE USAGE
    		EZThreatPrint("ERROR: You must specify a height to set the bar height.");
    		EZThreatPrint("Example: /EZThreat height 8");
    		return
    	end

    --set the height - check that its a valid value
        local rmanavaluecheck = tonumber(rmanacmd2); -- convert string to number
        if rmanavaluecheck > 3 and rmanavaluecheck < 501 then
        	--SET BAR HEIGHT
        	EZThreat_Frame:SetHeight(rmanavaluecheck);
        	EZThreatSettings["BarHeight"] = rmanavaluecheck; -- save the setting
        else
        	--error  -  invalid value
        	EZThreatPrint("ERROR: Invalid value for bar height. Must be between 4 and 500.");
        end



    elseif msg == "asdasgasgas" then
    --
   else
    --PRINT GENERAL HELP INFO HERE
    print("|cff66e4ffEZThreat Commands:|r");
    print("|cff669bff/EZThreat unlock|r - unlocks frames (and will show threat bar if it is empty so you can move it)");
    print("|cff669bff/EZThreat lock|r - locks frames.");
    print("|cff669bff/EZThreat lost|r - Clear Anchors and move EZThreat to the midddle of your screen.");
    print("|cff669bff/EZThreat width|r |cff70f5f5#|r - Sets the WIDTH of the BAR in pixels|cffcecece(default 151)|r");
    print("|cff669bff/EZThreat height|r |cff70f5f5#|r - Sets the HEIGHT of the BAR in pixels|cffcecece(default 8)|r");
end

end 

local function setbarcolor(frame, ezthreatpercent)
    --sets the status bar color for the frame based on the ezthreatpercent passed to it.
    if ezthreatpercent < 20 then
        frame:SetStatusBarColor(0, 0.4, 1);
    elseif ezthreatpercent < 30 then
        frame:SetStatusBarColor(0, 0.702, 1);
    elseif ezthreatpercent < 40 then
        frame:SetStatusBarColor(0, 1, 0.6);
    elseif ezthreatpercent < 50 then
        frame:SetStatusBarColor(0.427, 1, 0.141);
    elseif ezthreatpercent < 60 then
        frame:SetStatusBarColor(0.8, 1, 0.2);
    elseif ezthreatpercent < 70 then
        frame:SetStatusBarColor(0.961, 0.961, 0.141)
    elseif ezthreatpercent < 80 then
        frame:SetStatusBarColor(1, 0.784, 0);
    elseif ezthreatpercent < 90 then
        frame:SetStatusBarColor(0.961, 0.565, 0);
    else
        frame:SetStatusBarColor(0.902, 0, 0);

    end
end

local function settextcolor(ezthreatpercent)
--sets colorcoder based on the mana percent passed to it, for color-coding text based on mana %
    if ezthreatpercent < 20 then
        colorcoder = "|cff0066ff";
    elseif ezthreatpercent < 30 then
        colorcoder = "|cff00b3ff";
    elseif ezthreatpercent < 40 then
        colorcoder = "|cff00ff99";
    elseif ezthreatpercent < 50 then
        colorcoder = "|cff6dff24";
    elseif ezthreatpercent < 60 then
        colorcoder = "|cffccff33";
    elseif ezthreatpercent < 70 then
        colorcoder = "|cfff5f524";
    elseif ezthreatpercent < 80 then
        colorcoder = "|cffffc800";
    elseif ezthreatpercent < 90 then
        colorcoder = "|cffff5900";
    else
        colorcoder = "|cffe60000";
    end
end


-- actual update, includes colors of text/bars.
local function UpdateThreats(self, elapsed)

    TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;
    if TimeSinceLastUpdate > 0.5 then
        TimeSinceLastUpdate = 0
        local _,_,threatt,_,_ = UnitDetailedThreatSituation("player", "target");
        if not threatt or threatt == nil then
            threatt = 0
        end
        local EZThreatPercentage = threatt
        if isFrame1locked == false and EZThreatPercentage == 0 then
            EZThreatPercentage = 100
        elseif EZThreatPercentage > 0 then
            EZThreatPercentage = EZroundnumber(EZThreatPercentage)
        end

        EZThreat_Frame:SetValue(EZThreatPercentage)
        -- set statusbar and text color
        setbarcolor(EZThreat_Frame, EZThreatPercentage);
        settextcolor(EZThreatPercentage);
        -- set last known value
        lastknownthreatPct = EZThreatPercentage;

        EZThreatFontString:SetText("|cffffffffThreat: "..colorcoder..EZThreatPercentage.."%|r")
    end
end

function EZroundnumber(num, numDecimalPlaces)
  local mult = 10^(numDecimalPlaces or 0)
  return math.floor(num * mult + 0.5) / mult
end

-- Used to check if someone should be included in the mana calculation
local manaclasses = {"HUNTER", "PRIEST", "SHAMAN", "MAGE", "WARLOCK", "DRUID", "PALADIN"}; -- this line is obsolete now
local healclasses = {"PRIEST", "SHAMAN", "DRUID", "PALADIN"};
local dpsclasses = {"HUNTER", "MAGE", "WARLOCK"};




function EZThreat_OnLoad(self, event, ...)
    self:RegisterEvent("ADDON_LOADED")

end

function EZThreat_OnEvent(self, event, ...)
    if (event == "ADDON_LOADED" and ... == "EZThreat") then
        EZThreatPrint("Addon loaded! - v"..versionnumber)


        -- Initialize Saved Variables
        if EZThreatSettings == nil then
            -- first time the addon has been loaded, Initialize default Variables
            print("|cff66e4ffEZThreat|r|cff9999ff default settings loaded.|r");
            EZThreatSettings =
            {
                Frame1X = 314,
                Frame1Y = -1,
                Frame1Anchor1 = "BOTTOMLEFT",
                Frame1Anchor2 = "BOTTOMLEFT",
                Frame2X = 399,
                Frame2Y = 9,
                Frame2Anchor1 = "BOTTOMLEFT",
                Frame2Anchor2 = "BOTTOMLEFT",
                ShowDPS = true,
                BarWidth = 151,
                BarHeight = 8
            }


            -- if we add a new setting to the table we need to add a check for that saved var only and set its default. (not sure if the keys need quotes...)
            --elseif EZThreatSettings["NewSetting"] == nil then
                -- set its default

        end

        -- new variables for height and width of frame (added in a later version, need their own specific check)
        if EZThreatSettings["BarWidth"] == nil then
        	-- set bar width and height to default values!
        	EZThreatSettings["BarWidth"] = 151;
        	EZThreatSettings["BarHeight"] = 8;
        end

        self:UnregisterEvent("ADDON_LOADED")

        EZThreat:SetSize(50, 25)
        --X, Y offset from where to anchor the frame, from bottom center of minimap.
        EZThreat:SetPoint(EZThreatSettings["Frame1Anchor1"], nil, EZThreatSettings["Frame1Anchor2"], EZThreatSettings["Frame1X"], EZThreatSettings["Frame1Y"])
        EZThreat:SetScript("OnUpdate", UpdateThreats)

        --local EZThreatFont = EZThreat:CreateFontString("EZThreatFontString", "OVERLAY", "GameFontBlackTiny")
        -- inherit bigger font size
        local EZThreatFont = EZThreat:CreateFontString("EZThreatFontString", "OVERLAY", "GameFontNormalLargeLeft")
        EZThreatFont:SetPoint("CENTER", "EZThreat", "CENTER", 0, 0)
        EZThreatFont:Show()
        EZThreat:Show()
        -- create threat frame
        makeythreatframey()

    end

end




function makeythreatframey()
EZThreat_Frame = CreateFrame("StatusBar", nil, UIParent)

EZThreat_Frame:SetWidth(EZThreatSettings["BarWidth"])
EZThreat_Frame:SetHeight(EZThreatSettings["BarHeight"])
--[[
EZThreat_Frame:SetBackdrop({
    bgFile="Interface\DialogFrame\UI-DialogBox-Background", 
                    
    insets= {left = "11", right = "12", top = "12", bottom = "11"},
    edgeSize="32"})
--]]
EZThreat_Frame:SetPoint(EZThreatSettings["Frame2Anchor1"], nil, EZThreatSettings["Frame2Anchor2"], EZThreatSettings["Frame2X"], EZThreatSettings["Frame2Y"]);
EZThreat_Frame:SetOrientation("HORIZONTAL")
EZThreat_Frame:EnableMouse(true)
EZThreat_Frame:SetMovable(true)
EZThreat_Frame:SetUserPlaced(true);
EZThreat_Frame:RegisterForDrag("LeftButton")
--EZThreat_Frame:SetScript("OnEvent", eventHandler)
EZThreat_Frame:SetMinMaxValues(0, 100)
EZThreat_Frame:SetStatusBarTexture("Interface\\RaidFrame\\Raid-Bar-Hp-Fill")


-- Make frames draggable
EZThreat_Frame:SetScript("OnMouseDown", function(self, button)

    if isFrame2locked == false then
        EZThreat_Frame:StartMoving();
    end

end)

EZThreat_Frame:SetScript("OnMouseUp", function()
    EZThreat_Frame:StopMovingOrSizing()
end)


EZThreat:SetScript("OnMouseDown", function(self, button)
    
    if isFrame1locked == false then
        EZThreat:StartMoving();
    end

end)


EZThreat:SetScript("OnMouseUp", function()
    EZThreat:StopMovingOrSizing()
end)


end